//+------------------------------------------------------------------+
//|                               Jim Sloman's natural market mirror |
//|                                                      ocn nmm.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DimGray
#property indicator_color2  DeepSkyBlue
#property indicator_style1  STYLE_DOT

//
//
//
//
//

extern int   NMMPeriod  = 40;
extern int   NMMPrice   = PRICE_CLOSE;
extern int   TEMAPeriod = 10;

extern string TimeFrame      = "";
extern int    ShowValue      =  1;
extern int    Type           =  0;
extern double emaPeriod      =  1;
extern int    Lookback       =  1;
extern double SmoothLength   =  1;
extern double SmoothPhase    =  0;
extern bool   SmoothDouble   = false;
extern bool   Interpolate    = true;
extern bool   ShowTrigger    = false;
//
//
//
//
//

double nmm[];
double zeroLine[];
double tBuffer[][5];
double alpha;
int limit;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,zeroLine); SetIndexLabel(0,NULL);
   SetIndexBuffer(1,nmm);
    
   //
   //
   //
   //
   //

   string PriceType;
      switch(NMMPrice)
      {
         case PRICE_CLOSE:    PriceType = "Close";    break;  // 0
         case PRICE_OPEN:     PriceType = "Open";     break;  // 1
         case PRICE_HIGH:     PriceType = "High";     break;  // 2
         case PRICE_LOW:      PriceType = "Low";      break;  // 3
         case PRICE_MEDIAN:   PriceType = "Median";   break;  // 4
         case PRICE_TYPICAL:  PriceType = "Typical";  break;  // 5
         case PRICE_WEIGHTED: PriceType = "Weighted"; break;  // 6
      }      
  
      //
      //
      //
      //
      //
   
      TEMAPeriod = MathMax(TEMAPeriod,1);
      NMMPeriod  = MathMax(NMMPeriod ,1);
           alpha = 2.0 /(1.0 + TEMAPeriod);
           
   IndicatorShortName ("pal nmm ("+NMMPeriod+","+TEMAPeriod+","+TimeFrame+","+ShowValue+","+Type+","+DoubleToStr(emaPeriod,0)+","+Lookback+")");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define iPrc 3
#define iCorr 4

//
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   int    i,k,r;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);

   //
   //
   //
   //
   //
  double minVal = MathAbs(findMinPal(limit));
  
   for(i=limit, r=Bars-i-1; i >= 0; i--,r++)
   {
//      double rawPrice  = iCustom(NULL,0,"PalND_v1.59",TimeFrame,ShowValue,Type,emaPeriod,Lookback,SmoothLength,SmoothPhase,SmoothDouble,Interpolate,ShowTrigger,0,i);
      double rawPrice  = tBuffer[r][iCorr] + minVal;
      double currPrice = iTema(rawPrice,i);
         if (currPrice > 0)
         {  tBuffer[r][iPrc] = MathLog(currPrice);
         }else{
            tBuffer[r][iPrc] = 0.00;
            //Print("0Price@ "+i+" back");
         }
         //
         //
         //
         //
         //
         
         nmm[i]      = iNmmFunction(1,i);
         zeroLine[i] = 0.00;
   }
   
   //
   //
   //
   //
   //
   
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//    natural market mirror
//
//
//

double iNmmFunction(int startPeriod, int tPos)
{
   int    endPeriod = startPeriod*NMMPeriod;
   int    pos       = Bars-tPos-1;
   double sum       = 0.00;
   double currPrice = tBuffer[pos][iPrc];
      
   for (int i= startPeriod; i <= endPeriod; i += startPeriod)
           sum += (currPrice-tBuffer[pos-i][iPrc])/MathSqrt(i);
   return((sum/NMMPeriod)*1000.00);
}

//
//
//
//
//

double iTema(double price,int pos,int sbuf=0)
{
   int i  = Bars-pos-1;
   int ia = sbuf+0;
   int ib = sbuf+1;
   int ic = sbuf+2;
   
   if (i < 1)
      {
         tBuffer[i][ia] = price;
         tBuffer[i][ib] = price;
         tBuffer[i][ic] = price;
      }
   else
      {
         tBuffer[i][ia] = tBuffer[i-1][ia]+alpha*(price         -tBuffer[i-1][ia]);
         tBuffer[i][ib] = tBuffer[i-1][ib]+alpha*(tBuffer[i][ia]-tBuffer[i-1][ib]);
         tBuffer[i][ic] = tBuffer[i-1][ic]+alpha*(tBuffer[i][ib]-tBuffer[i-1][ic]);
      }
   return(3*tBuffer[i][ia] - 3*tBuffer[i][ib] + tBuffer[i][ic]);
}

double findMinPal(int& limit)
{
   double minPal = 0.0;
   int i, r;
   for(i=limit, r=Bars-i-1; i >= 0; i--,r++)
    {
      tBuffer[r][iCorr] = iCustom(NULL,0,"PalND_v1.59",TimeFrame,ShowValue,Type,emaPeriod,Lookback,SmoothLength,SmoothPhase,SmoothDouble,Interpolate,ShowTrigger,0,i);
      if (tBuffer[r][iCorr] < minPal) minPal = tBuffer[r][iCorr];    
    }
return(minPal);       
}